#!/usr/bin/python

import re, urllib

names_list = ['xaelar', 'eru_bahagon', 'lookatthis', 'vankusss','EddyMataGallos', 'Hendor', 'Analu', 'golfkid', 'Mr_lim', 'esp', 'toefacekiller', 'johnny_faneca', 'trib4lmaniac', 'macrohenry', 'glib_jase', 'ben_schultz_11']
ep_list = []
lvl_list = []
index_ep = 0 # shitty variable to print index, no idea how to do it cleaner
index_lvl = 0

def remove_html_tags_and_replace_them_with_whitespace(data): # does exactly what it says on the tin
        p = re.compile(r'<.*?>')
        return p.sub(' ', data)
    
def remove_extra_spaces(data):
        result = re.compile(r'\s+') # removes extra spaces (when you have tags following each other, the previous method will put multiple spaces). Here, we replace every sequence of more than one space by exactly one space
        return result.sub(' ', data)



for item in names_list:

    #wvhbflk63vf9991111111 = raw_input('Enter name here: ')
    url = urllib.urlopen('http://www.harveycartel.org/metanet/n/data13/n_highscores_u.php?name='+item)
    grapefruit = url.read()
    
        
    temp=remove_extra_spaces(remove_html_tags_and_replace_them_with_whitespace(grapefruit))
    
    fdsa=temp.split() # turns the thing into a list
    zxcv=fdsa[76:] # removes the 76 bits of trash at the beginning of the list
    ep_score=zxcv[:zxcv.index('level')-6] # episode scores
    lvl_score=zxcv[zxcv.index('level')+5:zxcv.index('Note:')] # level scores
    
    for blob in range(len(ep_score)/4-1): # removes duplicate episode scores, hopefully
        if ep_score[4*blob+2]==ep_score[4*blob+6] or int(ep_score[4*blob+6])>99: # matches episode numbers and removes scores with episode>99
            ep_score[4*blob+5]=0 # the second score will always be lower than the first, so set that one to 0
    
    for xaelar_smells in range(len(lvl_score)/4-1): # gets rid of duplicate level scores
        if lvl_score[4*xaelar_smells+2]==lvl_score[4*xaelar_smells+6] \
        and lvl_score[4*xaelar_smells+3]==lvl_score[4*xaelar_smells+7] \
        or int(lvl_score[4*xaelar_smells+6])>99: # matches the episode and level numbers and removes scores with episode>99
            lvl_score[4*xaelar_smells+5]=0 # removes the second, lower, score
    
    total_ep_score = sum(float(ep_score[4*i+1]) for i in range(len(ep_score)/4))
    total_lvl_score = sum(float(lvl_score[4*i+1]) for i in range(len(lvl_score)/4))
    
    #print 'Total episode score for', item, ':', sum(float(ep_score[4*i+1]) for i in range(len(ep_score)/4)) # returns total episode score
    #print 'Total level score for', item, ':', sum(float(lvl_score[4*i+1]) for i in range(len(lvl_score)/4)) # returns total level score

    ep_list.append((total_ep_score, item))
    lvl_list.append((total_lvl_score, item))

ep_list.sort()
ep_list.reverse() # to get it in descending order
lvl_list.sort()
lvl_list.reverse()

print "Total Episode Score Rankings"
print

for (v, k) in ep_list:
    print "%d %-15s : %.3f" % (index_ep, k, v) # nicer layout
    index_ep += 1 # seriously no index_ep++ in python ?

print 
print "Total Level Score Rankings"
print
for v, k in lvl_list:
    print "%d %-15s : %.3f" % (index_lvl, k, v) # nicer layout
    index_lvl += 1 